-- Enable reticle switch
Hooks:PostHook(BlackMarketGui, "populate_mods", "custom45degsights_bm_gui_enablereticleswitch", function(self, data)

	-- Most of this is copypasted code from BlackMarketGui:populate_mods, a very dense function
	-- This hook reruns the code responsible for adding the sight switcher menu, and sight preview on the mod icon.

	local crafted = managers.blackmarket:get_crafted_category(data.prev_node_data.category)[data.prev_node_data.slot]
	local global_values = crafted.global_values or {}
	
	local weapon_blueprint = managers.blackmarket:get_weapon_blueprint(data.prev_node_data.category, data.prev_node_data.slot) or {}
	local equipped = nil
	for i, mod in ipairs(data) do
		for _, weapon_mod in ipairs(weapon_blueprint) do
			if mod.name == weapon_mod and (not global_values[weapon_mod] or global_values[weapon_mod] == data[i].global_value) then
				equipped = i

				break
			end
		end
	end
	
	if not equipped then return end
	
	local factory = tweak_data.weapon.factory.parts[data[equipped].name]
	
	if not factory then return end
	
	if factory.force_reticle_switcher then
		-- Add reticle switcher menu
		table.insert(data[equipped], "wm_reticle_switch_menu")
		
		-- Draw reticle preview on the weapon mod icon
		local reticle_texture = managers.blackmarket:get_part_texture_switch(data[equipped].category, data[equipped].slot, data[equipped].name)

		if reticle_texture and reticle_texture ~= "" then
			data[equipped].mini_icons = data[equipped].mini_icons or {}

			table.insert(data[equipped].mini_icons, {
				layer = 2,
				h = 30,
				stream = true,
				w = 30,
				blend_mode = "add",
				bottom = 1,
				right = 1,
				texture = reticle_texture
			})
		end
	end
end)
